---
title: Deploy API Service
description: The POST {{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment request deploys an API service's managed policies.
component: pingone-api
page_id: pingone-api:authorize:api-access-management/api-services/deployment/post-deploy-api-server
canonical_url: https://developer.pingidentity.com/pingone-api/authorize/api-access-management/api-services/deployment/post-deploy-api-server.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  example-request: Example Request
  example-response: Example Response
---

# Deploy API Service

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment
```

The `POST {{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment` request deploys an API service's managed policies.

### Prerequisites

* To create an API service, refer to [Create API Service](../create-api-server.html).

* To find an existing API service, refer to [Read API Services](../read-api-servers.html).

> **Collapse: Request Model**
>
> For property descriptions, refer to [Deployment](../deployment.html).
>
> | Property               | Type?  | Required? |
> | ---------------------- | ------ | --------- |
> | `decisionEndpoint.id`  | String | Required  |
> | `status.code`          | String | Required  |
> | `status.error`         | Object | Optional  |
> | `status.error.id`      | String | Required  |
> | `status.error.code`    | String | Required  |
> | `status.error.message` | String | Required  |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/vnd.pingidentity.apiserver.deploy+json

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request POST '{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment' \
--header 'Content-Type: application/vnd.pingidentity.apiserver.deploy+json' \
--header 'Authorization: Bearer {{accessToken}}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/vnd.pingidentity.apiserver.deploy+json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment"
  method := "POST"

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, nil)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/vnd.pingidentity.apiserver.deploy+json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment HTTP/1.1
Host: {{apiPath}}
Content-Type: application/vnd.pingidentity.apiserver.deploy+json
Authorization: Bearer {{accessToken}}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/vnd.pingidentity.apiserver.deploy+json");
RequestBody body = RequestBody.create(mediaType, "");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment")
  .method("POST", body)
  .addHeader("Content-Type", "application/vnd.pingidentity.apiserver.deploy+json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/vnd.pingidentity.apiserver.deploy+json",
    "Authorization": "Bearer {{accessToken}}"
  },
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment',
  'headers': {
    'Content-Type': 'application/vnd.pingidentity.apiserver.deploy+json',
    'Authorization': 'Bearer {{accessToken}}'
  }
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment"

payload = {}
headers = {
  'Content-Type': 'application/vnd.pingidentity.apiserver.deploy+json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/vnd.pingidentity.apiserver.deploy+json',
  'Authorization' => 'Bearer {{accessToken}}'
));
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/vnd.pingidentity.apiserver.deploy+json"
request["Authorization"] = "Bearer {{accessToken}}"

response = http.request(request)
puts response.read_body
```

```swift
var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/apiServers/{{apiServerID}}/deployment")!,timeoutInterval: Double.infinity)
request.addValue("application/vnd.pingidentity.apiserver.deploy+json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/apiServers/a82aa1c1-1a8e-4b6e-a43e-2266ebd57626/deployment"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "apiServer": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/apiServers/a82aa1c1-1a8e-4b6e-a43e-2266ebd57626"
        },
        "decisionEndpoint": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/decisionEndpoints/4a3df58c-e3a4-4000-853b-32aa2a8ae9d2"
        }
    },
    "deployedAt": "2024-04-10T22:46:28.237Z",
    "status": {
        "code": "DEPLOYMENT_SUCCESSFUL"
    },
    "decisionEndpoint": {
        "id": "4a3df58c-e3a4-4000-853b-32aa2a8ae9d2"
    }
}
```
